<script setup lang="ts">
import ProductList from '@/views/pos/components/ProductList.vue'
import { onMounted, ref } from 'vue'
import { usePosStore } from '../stores/pos'
import type { Product } from '@/views/product/types/Product'
import type { ReceiptItem } from '@/views/receipt/types/receiptItem'
import ReceiptItemList from '../components/ReceiptItemList.vue'
import MemberCard from '../components/MemberCard.vue'
import ReceiptDialog from '../components/ReceiptDialog.vue'
import customerDialog from '@/views/customer/components/customerDialog.vue'
import ReceiptCard from '../components/ReceiptCard.vue'
import PaymentCard from '../components/PaymentCard.vue'
import CreditCardDialog from '../components/CreditCardDialog.vue'
import PromptPayDialog from '../components/PromptPayDialog.vue'
import PointCard from '../components/PointCard.vue'
import ActionsCard from '../components/ActionsCard.vue'
import SelectPromotionDialog from '../components/SelectPromotionDialog.vue'
// import { usePromotionStore } from '@/views/promotion/stores/promotion'
// import type { Promotion } from '@/views/promotion/types/Promotion'

const posStore = usePosStore()
// const promotionStore = usePromotionStore()
const snackbar = ref(false)
const showMemberBox = ref(false)
const product = ref<Product>()
// const selectPromotion = ref<Promotion[]>([])

function selected(p: Product) {
  if (!p.id) return

  product.value = p
  const newReceiptItem: ReceiptItem = {
    id: -1,
    name: p.name,
    price: p.price,
    unit: 1,
    total: p.price,
    productId: p.id
  }

  posStore.addReceiptItem(newReceiptItem)
  snackbar.value = true
}

const tab = ref(null)
onMounted(async () => {
  await posStore.fetchProducts()
})
</script>

<template>
  <!-- <img
    class="full-screen-img"
    src="https://www.shutterstock.com/image-photo/brown-roasted-coffee-beans-closeup-600nw-1925210999.jpg"
  /> -->
  <v-container class="fill-height" fluid>
    <v-row>
      <!-- Left Column -->
      <v-col cols="12" md="6" class="fill-height d-flex">
        <v-sheet width="100%" elevation="0" rounded class="fill-height">
          <!-- header -->
          <v-img
            height="100"
            src="https://i.pinimg.com/564x/22/49/84/224984972b3a833cb764dd7bdc512054.jpg"
            style="opacity: 1"
            cover
          >
            <v-container>
              <v-row>
                <v-col>
                  <h1
                    style="
                      font-family: cursive;
                      font-weight: bold;
                      color: rgb(255, 255, 255);
                      font-size: 35px;
                    "
                  >
                    Point of Sale
                  </h1>
                </v-col>
                <v-col></v-col>
              </v-row>
            </v-container>
          </v-img>

          <v-tabs v-model="tab" color="orange" align-tabs="start" class="ma-5">
            <v-tab :value="1"><v-icon icon="mdi-coffee"></v-icon>Drink</v-tab>
            <v-tab :value="2"><v-icon icon="mdi-cake-variant"></v-icon>Bakery</v-tab>
            <v-tab :value="3"><v-icon icon="mdi-silverware-fork-knife"></v-icon>Food</v-tab>
          </v-tabs>

          <v-window v-model="tab">
            <v-window-item :value="1" @click="posStore.fetchProducts">
              <ProductList :products="posStore.products1" @selected="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="2" @click="posStore.fetchProducts">
              <ProductList :products="posStore.products2" @selected="selected"></ProductList>
            </v-window-item>
            <v-window-item :value="3" @click="posStore.fetchProducts">
              <ProductList :products="posStore.products3" @selected="selected"></ProductList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>

      <!-- Right Column -->
      <v-col cols="12" md="6" class="fill-height d-flex">
        <v-sheet width="auto" elevation="0" rounded style="background-color: rgba(0, 0, 0, 0.8)">
          <v-row no-gutters>
            <v-col cols="12">
              <v-sheet elevation="0" rounded style="background-color: rgba(131, 131, 131, 0.466)">
                <v-img
                  height="80"
                  src="https://i.pinimg.com/564x/78/e3/7d/78e37d57fd461ee7fd594e1efe2715ce.jpg"
                  style="opacity: 1"
                  cover
                >
                  <h1
                    style="
                      font-family: cursive;
                      font-weight: bold;
                      color: #3e2723;
                      padding-left: 35px;
                      margin: 5px;
                      font-size: 38px;
                    "
                  >
                    Order List
                  </h1>
                </v-img>
                <ReceiptItemList
                  v-model="posStore.tempReceipt.receiptItems"
                  :editable="true"
                ></ReceiptItemList>
              </v-sheet>
            </v-col>

            <!-- MemberCard and PointCard -->
            <v-col cols="12" style="color: white">
              <h3 style="cursor: pointer" class="pl-5" @click="showMemberBox = !showMemberBox">
                Member Action<v-icon
                  :icon="showMemberBox ? 'mdi-chevron-up' : 'mdi-chevron-down'"
                ></v-icon>
              </h3>
              <v-expand-transition>
                <div v-show="showMemberBox">
                  <v-row no-gutters>
                    <v-col cols="6">
                      <v-sheet
                        width="auto"
                        height="150"
                        elevation="0"
                        style="background-color: #fef1dea4; color: black"
                      >
                        <MemberCard />
                      </v-sheet>
                    </v-col>
                    <v-col cols="6">
                      <v-sheet
                        width="auto"
                        height="150"
                        elevation="0"
                        style="background-color: #fef1dea4; color: black"
                      >
                        <PointCard></PointCard>
                      </v-sheet>
                    </v-col>
                  </v-row>
                </div>
              </v-expand-transition>
            </v-col>

            <v-col cols="6">
              <v-sheet
                min-width="200"
                height="160"
                elevation="0"
                class="clearColor"
                style="background-color: #3e2723b0; color: white"
              >
                <ReceiptCard />
              </v-sheet>
            </v-col>

            <v-col cols="6">
              <v-sheet
                min-width="200"
                height="160"
                elevation="0"
                class="clearColor"
                style="background-color: #3e2723b0; color: white"
              >
                <PaymentCard />
              </v-sheet>
            </v-col>
          </v-row>

          <!-- Buttons and Actions -->
          <ActionsCard></ActionsCard>
        </v-sheet>
      </v-col>
    </v-row>
  </v-container>

  <ReceiptDialog
    v-model:modelValue="posStore.dialogReceipt"
    :receipt="posStore.tempReceipt"
    :receiptItems="posStore.tempReceipt.receiptItems!"
  ></ReceiptDialog>
  <PromptPayDialog />
  <CreditCardDialog />
  <customerDialog></customerDialog>
  <SelectPromotionDialog></SelectPromotionDialog>
</template>
<style>
.full-screen-img {
  width: 100vw;
  height: 100vh;
  position: absolute;
  object-fit: cover;
  z-index: -100;
}
</style>
